<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>LibSylph: Sylph::Array&lt; T &gt;::Array::iterator Class Reference</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.8 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="classes.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="classes.html"><span>Class&nbsp;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="namespace_sylph.html">Sylph</a>::<a class="el" href="class_sylph_1_1_array.html">Array</a>::<a class="el" href="class_sylph_1_1_array_1_1iterator.html">iterator</a>
  </div>
</div>
<div class="contents">
<h1>Sylph::Array&lt; T &gt;::Array::iterator Class Reference</h1><!-- doxytag: class="Sylph::Array::iterator" --><!-- doxytag: inherits="RandomAccessIterator&lt; T, iterator &gt;" --><code>#include &lt;<a class="el" href="_array_8h-source.html">Sylph/Core/Array.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Sylph::Array&lt; T &gt;::Array::iterator:</div>
<div class="dynsection">
<p><center><img src="class_sylph_1_1_array_1_1iterator__inherit__graph.png" border="0" usemap="#_sylph_1_1_array_3_01_t_01_4_1_1_array_1_1iterator__inherit__map" alt="Inheritance graph"></center>
<map name="_sylph_1_1_array_3_01_t_01_4_1_1_array_1_1iterator__inherit__map">
<area shape="rect" id="node2" href="class_sylph_1_1_random_access_iterator.html" title="Sylph::RandomAccessIterator\&lt; T, iterator \&gt;" alt="" coords="5,237,325,267"><area shape="rect" id="node4" href="class_sylph_1_1_bidirectional_iterator.html" title="Sylph::BidirectionalIterator\&lt; T, iterator \&gt;" alt="" coords="16,160,315,189"><area shape="rect" id="node6" href="class_sylph_1_1_forward_iterator.html" title="Sylph::ForwardIterator\&lt; T, iterator \&gt;" alt="" coords="31,83,300,112"><area shape="rect" id="node8" href="class_sylph_1_1_object.html" title="The root of all classes." alt="" coords="109,5,221,35"></map>
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="class_sylph_1_1_array_1_1iterator-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">super::reference&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_array_1_1iterator.html#22bfc5f805fcbc5917ae279f451e110f">current</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight"><b>OVERRIDE THIS METHOD</b> Returns a reference to the object the <a class="el" href="class_sylph_1_1_array_1_1iterator.html">iterator</a> is currently pointing at.  <a href="#22bfc5f805fcbc5917ae279f451e110f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_array_1_1iterator.html#6dcf01f3b483a19c96faf73c8c829ce9">hasNext</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight"><b>OVERRIDE THIS METHOD</b> Tells wheter there are any objects left in the collection.  <a href="#6dcf01f3b483a19c96faf73c8c829ce9"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_array_1_1iterator.html#3c1145de7f34e2f9ad853369e418be0a">next</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight"><b>OVERRIDE THIS METHOD</b> Sets the <a class="el" href="class_sylph_1_1_array_1_1iterator.html">iterator</a> one place forward.  <a href="#3c1145de7f34e2f9ad853369e418be0a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_forward_iterator.html#6bc12e11b0e540d8788e8eab0cad19cd">equals</a> (const <a class="el" href="class_sylph_1_1_array_1_1iterator.html">iterator</a> &amp;other) const =0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight"><b>OVERRIDE THIS METHOD</b> Tells wheter this Iterator is equal to any other Iterator over the same type of collection.  <a href="#6bc12e11b0e540d8788e8eab0cad19cd"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="1448ef46fc3bf3ac2e65ed03eba0cb33"></a><!-- doxytag: member="Sylph::Array::iterator::_end_reached_" ref="1448ef46fc3bf3ac2e65ed03eba0cb33" args="" -->
bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_forward_iterator.html#1448ef46fc3bf3ac2e65ed03eba0cb33">_end_reached_</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Do not use or modify! <br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
<h3>template&lt;class T&gt;<br>
 class Sylph::Array&lt; T &gt;::iterator</h3>

<dl compact><dt><b><a class="el" href="todo.html#_todo000001">Todo:</a></b></dt><dd>Write documentation! </dd></dl>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="22bfc5f805fcbc5917ae279f451e110f"></a><!-- doxytag: member="Sylph::Array::iterator::current" ref="22bfc5f805fcbc5917ae279f451e110f" args="() const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">super::reference <a class="el" href="class_sylph_1_1_array.html">Sylph::Array</a>&lt; T &gt;::Array::iterator::current           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<b>OVERRIDE THIS METHOD</b> Returns a reference to the object the <a class="el" href="class_sylph_1_1_array_1_1iterator.html">iterator</a> is currently pointing at. 
<p>
Note that no beyond-the-end checking needs to be done, this is all done automagically for you. <dl class="return" compact><dt><b>Returns:</b></dt><dd>The object this <a class="el" href="class_sylph_1_1_array_1_1iterator.html">iterator</a> is currently pointing at. </dd></dl>

<p>Implements <a class="el" href="class_sylph_1_1_forward_iterator.html#0cfbb6d989c3cbbd37947fb1fa68ee24">Sylph::ForwardIterator&lt; T, iterator &gt;</a>.</p>

</div>
</div><p>
<a class="anchor" name="6bc12e11b0e540d8788e8eab0cad19cd"></a><!-- doxytag: member="Sylph::Array::iterator::equals" ref="6bc12e11b0e540d8788e8eab0cad19cd" args="(const iterator &amp;other) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="class_sylph_1_1_forward_iterator.html">Sylph::ForwardIterator</a>&lt; T , <a class="el" href="class_sylph_1_1_array_1_1iterator.html">iterator</a>  &gt;::equals           </td>
          <td>(</td>
          <td class="paramtype">const iterator  &amp;&nbsp;</td>
          <td class="paramname"> <em>other</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [pure virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<b>OVERRIDE THIS METHOD</b> Tells wheter this Iterator is equal to any other Iterator over the same type of collection. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>other</em>&nbsp;</td><td>An other ForwardIterator to compare this one against. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd><em>true</em> iff the two iterators are completely equal (i.e. they iteratate over the same collection and currently point to the same object), false otherwise. </dd></dl>

</div>
</div><p>
<a class="anchor" name="6dcf01f3b483a19c96faf73c8c829ce9"></a><!-- doxytag: member="Sylph::Array::iterator::hasNext" ref="6dcf01f3b483a19c96faf73c8c829ce9" args="() const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="class_sylph_1_1_array.html">Sylph::Array</a>&lt; T &gt;::Array::iterator::hasNext           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<b>OVERRIDE THIS METHOD</b> Tells wheter there are any objects left in the collection. 
<p>
This method should not take the past-the-end item into account. <dl class="return" compact><dt><b>Returns:</b></dt><dd><em>true</em> true if there are any next items, <em>false</em> if there are no more items left. </dd></dl>

<p>Implements <a class="el" href="class_sylph_1_1_forward_iterator.html#0c368995da59e9b3a2074bfccf8ac708">Sylph::ForwardIterator&lt; T, iterator &gt;</a>.</p>

</div>
</div><p>
<a class="anchor" name="3c1145de7f34e2f9ad853369e418be0a"></a><!-- doxytag: member="Sylph::Array::iterator::next" ref="3c1145de7f34e2f9ad853369e418be0a" args="() const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="class_sylph_1_1_array.html">Sylph::Array</a>&lt; T &gt;::Array::iterator::next           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<b>OVERRIDE THIS METHOD</b> Sets the <a class="el" href="class_sylph_1_1_array_1_1iterator.html">iterator</a> one place forward. 
<p>
Note that no beyond-the-end checking needs to be done, this is all done automagically for you. 
<p>Implements <a class="el" href="class_sylph_1_1_forward_iterator.html#c51a9015adb5e22568530c70efd6ff40">Sylph::ForwardIterator&lt; T, iterator &gt;</a>.</p>

</div>
</div><p>
</div>
<hr size="1" class="unhidden"><address style="text-align: right;"><small>
Documentation for LibSylph by Doxygen
</body>
</html>
